# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from pr2_gripper_sensor_msgs/PR2GripperEventDetectorData.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class PR2GripperEventDetectorData(genpy.Message):
  _md5sum = "9536d682ef6215440ecc47846d4117c2"
  _type = "pr2_gripper_sensor_msgs/PR2GripperEventDetectorData"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Time the data was recorded at
time stamp

# true if the trigger conditions have been met 
# (see PR2GripperEventDetectorCommand)
bool trigger_conditions_met

# true if the pressure sensors detected a slip event
# slip events occur when the finger pressure sensors
# high-freq. content exceeds the slip_trigger_magnitude variable
# (see PR2GripperEventDetectorCommand)
bool slip_event

# true if the hand-mounted accelerometer detected a contact acceleration
# acceleration events occur when the palm accelerometer
# high-freq. content exceeds the acc_trigger_magnitude variable
# (see PR2GripperEventDetectorCommand)
bool acceleration_event

# the high-freq acceleration vector that was last seen (x,y,z)
float64[3] acceleration_vector"""
  __slots__ = ['stamp','trigger_conditions_met','slip_event','acceleration_event','acceleration_vector']
  _slot_types = ['time','bool','bool','bool','float64[3]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stamp,trigger_conditions_met,slip_event,acceleration_event,acceleration_vector

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PR2GripperEventDetectorData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.trigger_conditions_met is None:
        self.trigger_conditions_met = False
      if self.slip_event is None:
        self.slip_event = False
      if self.acceleration_event is None:
        self.acceleration_event = False
      if self.acceleration_vector is None:
        self.acceleration_vector = [0.] * 3
    else:
      self.stamp = genpy.Time()
      self.trigger_conditions_met = False
      self.slip_event = False
      self.acceleration_event = False
      self.acceleration_vector = [0.] * 3

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I3B().pack(_x.stamp.secs, _x.stamp.nsecs, _x.trigger_conditions_met, _x.slip_event, _x.acceleration_event))
      buff.write(_get_struct_3d().pack(*self.acceleration_vector))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.stamp.secs, _x.stamp.nsecs, _x.trigger_conditions_met, _x.slip_event, _x.acceleration_event,) = _get_struct_2I3B().unpack(str[start:end])
      self.trigger_conditions_met = bool(self.trigger_conditions_met)
      self.slip_event = bool(self.slip_event)
      self.acceleration_event = bool(self.acceleration_event)
      start = end
      end += 24
      self.acceleration_vector = _get_struct_3d().unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I3B().pack(_x.stamp.secs, _x.stamp.nsecs, _x.trigger_conditions_met, _x.slip_event, _x.acceleration_event))
      buff.write(self.acceleration_vector.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.stamp.secs, _x.stamp.nsecs, _x.trigger_conditions_met, _x.slip_event, _x.acceleration_event,) = _get_struct_2I3B().unpack(str[start:end])
      self.trigger_conditions_met = bool(self.trigger_conditions_met)
      self.slip_event = bool(self.slip_event)
      self.acceleration_event = bool(self.acceleration_event)
      start = end
      end += 24
      self.acceleration_vector = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I3B = None
def _get_struct_2I3B():
    global _struct_2I3B
    if _struct_2I3B is None:
        _struct_2I3B = struct.Struct("<2I3B")
    return _struct_2I3B
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
