// Auto-generated. Do not edit!

// (in-package pr2_gripper_sensor_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let PR2GripperFindContactData = require('./PR2GripperFindContactData.js');

//-----------------------------------------------------------

class PR2GripperFindContactFeedback {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.data = null;
    }
    else {
      if (initObj.hasOwnProperty('data')) {
        this.data = initObj.data
      }
      else {
        this.data = new PR2GripperFindContactData();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PR2GripperFindContactFeedback
    // Serialize message field [data]
    bufferOffset = PR2GripperFindContactData.serialize(obj.data, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PR2GripperFindContactFeedback
    let len;
    let data = new PR2GripperFindContactFeedback(null);
    // Deserialize message field [data]
    data.data = PR2GripperFindContactData.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 44;
  }

  static datatype() {
    // Returns string type for a message object
    return 'pr2_gripper_sensor_msgs/PR2GripperFindContactFeedback';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a1cc8c2fc9268b550e6167f268f97574';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # feedback
    PR2GripperFindContactData data
    
    
    
    ================================================================================
    MSG: pr2_gripper_sensor_msgs/PR2GripperFindContactData
    # Time the data was recorded at
    time stamp
    
    # true when our contact conditions have been met
    # (see PR2GripperFindContact command)
    bool contact_conditions_met
    
    # the finger contact conditions 
    # true if the finger experienced a contact event
    #
    # contact events are defined as contact with the fingerpads
    # as either steady-state or high-freq force events
    bool left_fingertip_pad_contact
    bool right_fingertip_pad_contact
    
    # the force experinced by the finger Pads  (N)
    # NOTE:this ignores data from the edges of the finger pressure
    float64 left_fingertip_pad_force
    float64 right_fingertip_pad_force
    
    # the current joint position (m)
    float64 joint_position
    
    # the virtual (parallel) joint effort (N)
    float64 joint_effort
    
    # the control state of our realtime controller
    PR2GripperSensorRTState rtstate
    ================================================================================
    MSG: pr2_gripper_sensor_msgs/PR2GripperSensorRTState
    # the control state of our realtime controller
    int8 realtime_controller_state
    
    # predefined values to indicate our realtime_controller_state
    int8 DISABLED = 0
    int8 POSITION_SERVO = 3
    int8 FORCE_SERVO = 4
    int8 FIND_CONTACT = 5
    int8 SLIP_SERVO = 6
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PR2GripperFindContactFeedback(null);
    if (msg.data !== undefined) {
      resolved.data = PR2GripperFindContactData.Resolve(msg.data)
    }
    else {
      resolved.data = new PR2GripperFindContactData()
    }

    return resolved;
    }
};

module.exports = PR2GripperFindContactFeedback;
