// Auto-generated. Do not edit!

// (in-package pr2_gripper_sensor_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let PR2GripperReleaseGoal = require('./PR2GripperReleaseGoal.js');
let actionlib_msgs = _finder('actionlib_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class PR2GripperReleaseActionGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.goal_id = null;
      this.goal = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('goal_id')) {
        this.goal_id = initObj.goal_id
      }
      else {
        this.goal_id = new actionlib_msgs.msg.GoalID();
      }
      if (initObj.hasOwnProperty('goal')) {
        this.goal = initObj.goal
      }
      else {
        this.goal = new PR2GripperReleaseGoal();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PR2GripperReleaseActionGoal
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [goal_id]
    bufferOffset = actionlib_msgs.msg.GoalID.serialize(obj.goal_id, buffer, bufferOffset);
    // Serialize message field [goal]
    bufferOffset = PR2GripperReleaseGoal.serialize(obj.goal, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PR2GripperReleaseActionGoal
    let len;
    let data = new PR2GripperReleaseActionGoal(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [goal_id]
    data.goal_id = actionlib_msgs.msg.GoalID.deserialize(buffer, bufferOffset);
    // Deserialize message field [goal]
    data.goal = PR2GripperReleaseGoal.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += actionlib_msgs.msg.GoalID.getMessageSize(object.goal_id);
    return length + 17;
  }

  static datatype() {
    // Returns string type for a message object
    return 'pr2_gripper_sensor_msgs/PR2GripperReleaseActionGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e5f06f3717f8990527330a2e0eaa0c81';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    
    Header header
    actionlib_msgs/GoalID goal_id
    PR2GripperReleaseGoal goal
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: actionlib_msgs/GoalID
    # The stamp should store the time at which this goal was requested.
    # It is used by an action server when it tries to preempt all
    # goals that were requested before a certain time
    time stamp
    
    # The id provides a way to associate feedback and
    # result message with specific goal requests. The id
    # specified must be unique.
    string id
    
    
    ================================================================================
    MSG: pr2_gripper_sensor_msgs/PR2GripperReleaseGoal
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    #goal
    PR2GripperReleaseCommand command
    
    ================================================================================
    MSG: pr2_gripper_sensor_msgs/PR2GripperReleaseCommand
    # the event conditions we would like to trigger the robot to release on
    PR2GripperEventDetectorCommand event
    ================================================================================
    MSG: pr2_gripper_sensor_msgs/PR2GripperEventDetectorCommand
    # state variable that defines what events we would like to trigger on
    # Leaving this field blank will result in the robot triggering when 
    # anything touches the sides of the finger or an impact is detected
    # with the hand/arm.
    int8 trigger_conditions
    # definitions for our various trigger_conditions values
    # trigger on either acceleration contact or finger sensor side impact
    int8 FINGER_SIDE_IMPACT_OR_ACC = 0
    # tigger once  both slip and acceleration signals occur
    int8 SLIP_AND_ACC = 1 
    #  trigger on either slip, acceleration, or finger sensor side impact
    int8 FINGER_SIDE_IMPACT_OR_SLIP_OR_ACC = 2
    # trigger only on slip information
    int8 SLIP = 3
    # trigger only on acceleration contact information
    int8 ACC = 4 
    
    
    # the amount of acceleration to trigger on (acceleration vector magnitude)
    # Units = m/s^2
    # The user needs to be concerned here about not setting the trigger too
    # low so that is set off by the robot's own motions.
    #
    # For large rapid motions, say by a motion planner, 5 m/s^2 is a good level
    # For small delicate controlled motions this can be set MUCH lower (try 2.0)
    #
    # NOTE: When moving the gripper joint (opening/closing the grippr)
    # the high gearing of the PR2 gripper causes large acceleration vibrations
    # which will cause triggering to occur. This is a known drawback of the PR2.
    #
    # NOTE: Leaving this value blank will result in a 0 m/s^2 trigger. If you
    # are using a trigger_conditions value that returns on acceleration contact
    # events then it will immediately exceed your trigger and return
    float64 acceleration_trigger_magnitude
    
    
    # the slip detector gain to trigger on (either finger) : try 0.01
    # higher values decrease slip sensitivty (to a point)
    # lower values increase sensitivity (to a point)
    #
    # NOTE: Leaving this value blank will result in the most sensitive slip level.
    float64 slip_trigger_magnitude
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PR2GripperReleaseActionGoal(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.goal_id !== undefined) {
      resolved.goal_id = actionlib_msgs.msg.GoalID.Resolve(msg.goal_id)
    }
    else {
      resolved.goal_id = new actionlib_msgs.msg.GoalID()
    }

    if (msg.goal !== undefined) {
      resolved.goal = PR2GripperReleaseGoal.Resolve(msg.goal)
    }
    else {
      resolved.goal = new PR2GripperReleaseGoal()
    }

    return resolved;
    }
};

module.exports = PR2GripperReleaseActionGoal;
