// Auto-generated. Do not edit!

// (in-package pr2_gripper_sensor_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let PR2GripperSlipServoData = require('./PR2GripperSlipServoData.js');

//-----------------------------------------------------------

class PR2GripperSlipServoResult {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.data = null;
    }
    else {
      if (initObj.hasOwnProperty('data')) {
        this.data = initObj.data
      }
      else {
        this.data = new PR2GripperSlipServoData();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PR2GripperSlipServoResult
    // Serialize message field [data]
    bufferOffset = PR2GripperSlipServoData.serialize(obj.data, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PR2GripperSlipServoResult
    let len;
    let data = new PR2GripperSlipServoResult(null);
    // Deserialize message field [data]
    data.data = PR2GripperSlipServoData.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 45;
  }

  static datatype() {
    // Returns string type for a message object
    return 'pr2_gripper_sensor_msgs/PR2GripperSlipServoResult';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '1b10af616c7e94f609790b12cde04c6d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    
    #result
    PR2GripperSlipServoData data
    
    
    ================================================================================
    MSG: pr2_gripper_sensor_msgs/PR2GripperSlipServoData
    # time the data was recorded at
    time stamp
    
    # the amount of deformation from action start (in meters)
    float64 deformation
    
    # the force experinced by the finger Pads  (N)
    # NOTE:this ignores data from the edges of the finger pressure
    float64 left_fingertip_pad_force
    float64 right_fingertip_pad_force
    
    # the current virtual parallel joint effort of the gripper (in N)
    float64 joint_effort
    
    # true if the object recently slipped
    bool slip_detected
    
    # true if we are at or exceeding the deformation limit
    # (see wiki page and param server for more info)
    bool deformation_limit_reached
    
    # true if we are at or exceeding our force 
    # (see wiki page and param server for more info)
    bool fingertip_force_limit_reached
    
    # true if the controller thinks the gripper is empty
    # (see wiki page for more info)
    bool gripper_empty
    
    # the control state of our realtime controller
    PR2GripperSensorRTState rtstate
    ================================================================================
    MSG: pr2_gripper_sensor_msgs/PR2GripperSensorRTState
    # the control state of our realtime controller
    int8 realtime_controller_state
    
    # predefined values to indicate our realtime_controller_state
    int8 DISABLED = 0
    int8 POSITION_SERVO = 3
    int8 FORCE_SERVO = 4
    int8 FIND_CONTACT = 5
    int8 SLIP_SERVO = 6
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PR2GripperSlipServoResult(null);
    if (msg.data !== undefined) {
      resolved.data = PR2GripperSlipServoData.Resolve(msg.data)
    }
    else {
      resolved.data = new PR2GripperSlipServoData()
    }

    return resolved;
    }
};

module.exports = PR2GripperSlipServoResult;
